from utils import *
from simulate import Event


class Block:
    def __init__(self, nodeID, ID, transactions, previous_block_ID):
        # Initialize block attributes
        self.blk_Id = ID
        self.transactions = transactions
        self.prev_blk_Id = previous_block_ID
        self.pow_user_id = nodeID
        return


class Blockchain:
    def __init__(self):
        # Initialize blockchain attributes
        # TODO: Should broadcast the genesis block
        self.chain = {}
        self.genensis_block = Block(-1, gen_hash(GENESIS_SECRET), [], -1)
        self.chain[self.genensis_block.blk_Id] = (self.genensis_block, 0)  #
        self.head = self.genensis_block.blk_Id
        self.len_longest_chain = 1
        self.seen_transactions = set()
        self.pending_transactions = set()
        self.next_pow_completion_time = 0

    def get_chain_length(self, blk_Id=None):
        # Return the length of the longest chain
        if blk_Id is None:
            curr = self.head
        curr = blk_Id
        cnt = 0
        while curr != self.genensis_block.blk_Id:
            if curr not in self.chain:
                print("ERROR: Block not found in the chain")
                break
            curr = self.chain[curr].prev_blk_Id
            cnt += 1
        return cnt

    def receive_txn(self, txn):
        """
        Receive transaction from a neighbor
        if already seen, return 0 else return 1
        """
        if txn in self.seen_transactions:
            return 0
        else:
            self.seen_transactions.add(txn_id)
            self.pending_transactions.add(txn)
            return 1

    def verify_blk(self, blk):
        """
        Verify the block
        if valid, return 1 else 0
        """
        return 1

    def add_mined_block(self, blk):
        """
        Add the mined block to the blockchain
        """
        return

    def print_chain(self):
        pass

    def already_exist(self, blk):
        print(blk, self.chain.get(blk.blk_Id))
        exit()
        if blk.blk_Id in self.chain:
            return True
        return False

    def received_txn(self, txn):
        if txn in self.pending_transactions or txn in self.seen_transactions:
            return False

        self.pending_transactions.add(txn)
        return True
